'use strict';

var _ = require('lodash');

var createExporter = require('../exporter');

var template = "\"background-color\": \"{{=c.background}}\",\n\"foreground-color\": \"{{=c.foreground}}\",\n\"cursor-color\":     \"{{=c.foreground}}\",\n\"color-palette-overrides\": [\"{{=c[0]}}\",\"{{=c[1]}}\",\"{{=c[2]}}\",\"{{=c[3]}}\",\"{{=c[4]}}\",\"{{=c[5]}}\",\"{{=c[6]}}\",\"{{=c[7]}}\",\"{{=c[8]}}\",\"{{=c[9]}}\",\"{{=c[10]}}\",\"{{=c[11]}}\",\"{{=c[12]}}\",\"{{=c[13]}}\",\"{{=c[14]}}\",\"{{=c[15]}}\"]\n";

module.exports = {

  export: createExporter(template, function (colors) {
    var scheme = _.mapValues(colors, function (color) {
      return color.toHex();
    });

    var bg = colors.background.toRgbArray();
    scheme.backgroundR = bg[0];
    scheme.backgroundG = bg[1];
    scheme.backgroundB = bg[2];

    var fg = colors.foreground.toRgbArray();
    scheme.foregroundR = fg[0];
    scheme.foregroundG = fg[1];
    scheme.foregroundB = fg[2];

    return scheme;
  }),

};
