'use strict';

var _ = require('lodash');

var createExporter = require('../exporter');

var template = "/* Terminal colors (16 first used in escape sequence) */\nstatic const char *colorname[] = {\n\n  /* 8 normal colors */\n  [0] = \"{{=c[0]}}\", /* black   */\n  [1] = \"{{=c[1]}}\", /* red     */\n  [2] = \"{{=c[2]}}\", /* green   */\n  [3] = \"{{=c[3]}}\", /* yellow  */\n  [4] = \"{{=c[4]}}\", /* blue    */\n  [5] = \"{{=c[5]}}\", /* magenta */\n  [6] = \"{{=c[6]}}\", /* cyan    */\n  [7] = \"{{=c[7]}}\", /* white   */\n\n  /* 8 bright colors */\n  [8]  = \"{{=c[8]}}\", /* black   */\n  [9]  = \"{{=c[9]}}\", /* red     */\n  [10] = \"{{=c[10]}}\", /* green   */\n  [11] = \"{{=c[11]}}\", /* yellow  */\n  [12] = \"{{=c[12]}}\", /* blue    */\n  [13] = \"{{=c[13]}}\", /* magenta */\n  [14] = \"{{=c[14]}}\", /* cyan    */\n  [15] = \"{{=c[15]}}\", /* white   */\n\n  /* special colors */\n  [256] = \"{{=c.background}}\", /* background */\n  [257] = \"{{=c.foreground}}\", /* foreground */\n};\n\n/*\n * Default colors (colorname index)\n * foreground, background, cursor\n */\nstatic unsigned int defaultfg = 257;\nstatic unsigned int defaultbg = 256;\nstatic unsigned int defaultcs = 257;\n\n/*\n * Colors used, when the specific fg == defaultfg. So in reverse mode this\n * will reverse too. Another logic would only make the simple feature too\n * complex.\n */\nstatic unsigned int defaultitalic = 7;\nstatic unsigned int defaultunderline = 7;\n";

module.exports = {

  export: createExporter(template, _.partialRight(_.mapValues, function (color) {
    return color.toHex();
  }))

};
