'use strict';

var _ = require('lodash');

var createExporter = require('../exporter');

var template = "[global_config]\n  title_transmit_fg_color = \"{{=c.foreground}}\"\n  title_transmit_bg_color = \"{{=c[0]}}\"\n  title_inactive_fg_color = \"{{=c.foreground}}\"\n  title_inactive_bg_color = \"{{=c[8]}}\"\n\n[profiles]\n  [[default]]\n    palette = \"{{=c[0]}}:{{=c[1]}}:{{=c[2]}}:{{=c[3]}}:{{=c[4]}}:{{=c[5]}}:{{=c[6]}}:{{=c[7]}}:{{=c[8]}}:{{=c[9]}}:{{=c[10]}}:{{=c[11]}}:{{=c[12]}}:{{=c[13]}}:{{=c[14]}}:{{=c[15]}}\"\n    foreground_color = \"{{=c.foreground}}\"\n    background_color = \"{{=c.background}}\"\n    cursor_color = \"{{=c.foreground}}\"\n\n[layouts]\n  [[default]]\n    [[[child1]]]\n      type = Terminal\n      parent = window0\n      profile = default\n    [[[window0]]]\n      type = Window\n      parent = \"\"\n[plugins]\n";

module.exports = {

  export: createExporter(template, _.partialRight(_.mapValues, function (color) {
    return color.toHex();
  }))

};
